﻿using System.Linq;
using System.Windows.Forms;
using FarPoint.Win.Spread;
using FarPoint.Win.Spread.CellType;

namespace CopyPasteSpreadTest
{

   public partial class MainForm : Form
   {
      private FpSpread fpSpread1;
      private SheetView fpSpread1_Sheet1;

      private void InitSpread()
      {
         fpSpread1 = new FpSpread();
         fpSpread1_Sheet1 = new SheetView();
         // 
         // fpSpread1
         // 
         fpSpread1.AccessibleDescription = "";
         fpSpread1.Dock = DockStyle.Fill;
         fpSpread1.Location = new System.Drawing.Point(0, 0);
         fpSpread1.Name = "fpSpread1";
         fpSpread1.Sheets.AddRange(new[] {fpSpread1_Sheet1});
         fpSpread1.Size = new System.Drawing.Size(466, 445);
         fpSpread1.TabIndex = 0;
         // 
         // fpSpread1_Sheet1
         // 
         fpSpread1_Sheet1.Reset();
         fpSpread1_Sheet1.SheetName = "Sheet1";
         fpSpread1_Sheet1.ReferenceStyle = FarPoint.Win.Spread.Model.ReferenceStyle.R1C1;
         fpSpread1_Sheet1.RowHeader.Columns.Default.Resizable = false;
         fpSpread1_Sheet1.ReferenceStyle = FarPoint.Win.Spread.Model.ReferenceStyle.A1;
         // 
         // MainForm
         // 
         Controls.Add(fpSpread1);
         Name = "MainForm";
         Text = "CopyPasteSpreadTest";
      }

      public MainForm()
      {
         InitializeComponent();
         InitSpread();
         fpSpread1.AutoClipboard = true;

         var col1Combo = new MyComboBoxCellType(); // Paste works.
         col1Combo.Items = new[] { "foo", "bar"};
         fpSpread1_Sheet1.Columns.Get(0).CellType = col1Combo;

         for(int i=0; i<10; i++)
         {
            var col2Combo = new MyComboBoxCellType(); // Paste doesn't work (but do work when changing to "new ComboBoxCellType()")
            col2Combo.Items = new[] { "hello", "world" };

            Cell cellCol2 = fpSpread1_Sheet1.Cells[i, 1];
            cellCol2.CellType = col2Combo;
            cellCol2.Value = (i%2 == 0 ? col2Combo.Items.First() : col2Combo.Items.Last());
            
            Cell cellCol1 = fpSpread1_Sheet1.Cells[i, 0];
            cellCol1.Value = (i % 2 == 0 ? col1Combo.Items.First() : col1Combo.Items.Last());
         }
      }
   }

   public class MyComboBoxCellType : ComboBoxCellType
   {
      // Empty subclass of ComboBoxCellType.
   }

  
}
